﻿using System.Collections.Generic;
using TSLab.Script.Handlers;

namespace Indicators.TSLab.Misc {
  [HandlerName("Сумма за переменный интервал")]
  [Input( 0, TemplateTypes.DOUBLE, Name = "Значения" )]
  [Input( 1, TemplateTypes.DOUBLE, Name = "Период" )]
  public class SumOf : IDoubleAccumHandler, IValuesHandlerWithNumber, IContextUses {
    public IList<double> Execute(IList<double> price, IList<double> period) {
      int count = price.Count;
      if (period.Count != count)
        return new double[0];

      var values = new double[count];
      for (int i = 0; i < count; i++) {
        int s = i - (int) (period[i] - 1 + 0.5);
        if (s < 0)
          s = 0;

        double sum = 0;
        for (int j = s; j <= i; j++)
          sum += price[j];

        values[i] = sum;
      }
      return values;
    }

    double[] _prices;

    public double Execute(double price, double period, int i) {
      if (Context.BarsCount <= i)
        return price;

      if (_prices == null)
        _prices = new double[Context.BarsCount];
      _prices[i] = price;

      int s = i - (int) (period - 1 + 0.5);
      if (s < 0)
        s = 0;

      double sum = 0;
      for (int j = s; j <= i; j++)
        sum += _prices[j];

      return sum;
    }

    public IContext Context { set; get; }
  }
}